OGRE: Ogre::RenderWindow Class Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Friends

# Ogre::RenderWindow Class Reference
[RenderSystem]

Manages the target rendering window. More...

`#include <OgreRenderWindow.h>`

Inheritance diagram for Ogre::RenderWindow:
[legend]

List of all members.

## Public Types
enum | StatFlags { SF_NONE = 0, SF_FPS = 1, SF_AVG_FPS = 2, SF_BEST_FPS = 4, SF_WORST_FPS = 8, SF_TRIANGLE_COUNT = 16, SF_ALL = 0xFFFF }
enum | FrameBuffer { FB_FRONT, FB_BACK, FB_AUTO }
## Public Member Functions
| RenderWindow ()
| Default constructor.
virtual void | create (const String &name, unsigned int width, unsigned int height, bool fullScreen, const NameValuePairList *miscParams)=0
| Creates & displays the new window.
virtual void | setFullscreen (bool fullScreen, unsigned int width, unsigned int height)
| Alter fullscreen mode options.
virtual void | destroy (void)=0
| Destroys the window.
virtual void | resize (unsigned int width, unsigned int height)=0
| Alter the size of the window.
virtual void | windowMovedOrResized ()
| Notify that the window has been resized.
virtual void | reposition (int left, int top)=0
| Reposition the window.
virtual bool | isVisible (void) const
| Indicates whether the window is visible (not minimized or obscured).
virtual void | setVisible (bool visible)
| Set the visibility state.
virtual bool | isActive (void) const
| Overridden from RenderTarget, flags invisible windows as inactive.
virtual bool | isClosed (void) const =0
| Indicates whether the window has been closed by the user.
virtual bool | isPrimary (void) const
| Indicates whether the window is the primary window.
virtual bool | isFullScreen (void) const
| Returns true if window is running in fullscreen mode.
virtual void | getMetrics (unsigned int &width, unsigned int &height, unsigned int &colourDepth, int &left, int &top)
| Overloaded version of getMetrics from RenderTarget, including extra details specific to windowing systems.
PixelFormat | suggestPixelFormat () const
| Override since windows don't usually have alpha.
bool | isDeactivatedOnFocusChange () const
| Returns true if the window will automatically de-activate itself when it loses focus.
void | setDeactivateOnFocusChange (bool deactivate)
| Indicates whether the window will automatically deactivate itself when it loses focus.
virtual const String & | getName (void) const
| Retrieve target's name.
virtual void | getMetrics (unsigned int &width, unsigned int &height, unsigned int &colourDepth)
| Retrieve information about the render target.
virtual unsigned int | getWidth (void) const
virtual unsigned int | getHeight (void) const
virtual unsigned int | getColourDepth (void) const
virtual void | update (bool swapBuffers=true)
| Tells the target to update it's contents.
virtual void | swapBuffers (bool waitForVSync=true)
| Swaps the frame buffers to display the next frame.
virtual Viewport * | addViewport (Camera *cam, int ZOrder=0, float left=0.0f, float top=0.0f, float width=1.0f, float height=1.0f)
| Adds a viewport to the rendering target.
virtual unsigned short | getNumViewports (void) const
| Returns the number of viewports attached to this target.
virtual Viewport * | getViewport (unsigned short index)
| Retrieves a pointer to the viewport with the given index.
virtual void | removeViewport (int ZOrder)
| Removes a viewport at a given ZOrder.
virtual void | removeAllViewports (void)
| Removes all viewports on this target.
virtual void | getStatistics (float &lastFPS, float &avgFPS, float &bestFPS, float &worstFPS) const
| Retieves details of current rendering performance.
virtual const FrameStats & | getStatistics (void) const
virtual float | getLastFPS () const
| Individual stats access - gets the number of frames per second (FPS) based on the last frame rendered.
virtual float | getAverageFPS () const
| Individual stats access - gets the average frames per second (FPS) since call to Root::startRendering.
virtual float | getBestFPS () const
| Individual stats access - gets the best frames per second (FPS) since call to Root::startRendering.
virtual float | getWorstFPS () const
| Individual stats access - gets the worst frames per second (FPS) since call to Root::startRendering.
virtual float | getBestFrameTime () const
| Individual stats access - gets the best frame time.
virtual float | getWorstFrameTime () const
| Individual stats access - gets the worst frame time.
virtual void | resetStatistics (void)
| Resets saved frame-rate statistices.
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
virtual void | addListener (RenderTargetListener *listener)
| Add a listener to this RenderTarget which will be called back before & after rendering.
virtual void | removeListener (RenderTargetListener *listener)
| Removes a RenderTargetListener previously registered using addListener.
virtual void | removeAllListeners (void)
| Removes all listeners from this instance.
virtual void | setPriority (uchar priority)
| Sets the priority of this render target in relation to the others.
virtual uchar | getPriority () const
| Gets the priority of a render target.
virtual void | setActive (bool state)
| Used to set the active state of the render target.
virtual void | setAutoUpdated (bool autoupdate)
| Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
virtual bool | isAutoUpdated (void) const
| Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
virtual void | copyContentsToMemory (const PixelBox &dst, FrameBuffer buffer=FB_AUTO)=0
| Copies the current contents of the render target to a pixelbox.
void | writeContentsToFile (const String &filename)
| Writes the current contents of the render target to the named file.
virtual String | writeContentsToTimestampedFile (const String &filenamePrefix, const String &filenameSuffix)
| Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.
virtual bool | requiresTextureFlipping () const =0
virtual size_t | getTriangleCount (void) const
| Gets the number of triangles rendered in the last update() call.
virtual size_t | getBatchCount (void) const
| Gets the number of batches rendered in the last update() call.
virtual void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify a render target that a camera has been removed, incase it was referring to it as a viewer.
virtual bool | isHardwareGammaEnabled () const
| Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.
virtual uint | getFSAA () const
| Indicates whether multisampling is performed on rendering and at what level.
virtual const String & | getFSAAHint () const
| Gets the FSAA hint (.
virtual Impl * | _getImpl ()
| Get rendersystem specific interface for this RenderTarget.
virtual void | _beginUpdate ()
| Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.
virtual void | _updateViewport (int zorder, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
virtual void | _updateViewport (Viewport *viewport, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
virtual void | _updateAutoUpdatedViewports (bool updateStatistics=true)
| Method for manual management of rendering - renders only viewports that are auto updated.
virtual void | _endUpdate ()
| Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef map< int, Viewport * > ::type | ViewportList
typedef vector < RenderTargetListener * > ::type | RenderTargetListenerList
## Protected Member Functions
void | _setPrimary ()
| Indicates that this is the primary window.
void | updateStats (void)
virtual void | firePreUpdate (void)
| internal method for firing events
virtual void | firePostUpdate (void)
| internal method for firing events
virtual void | fireViewportPreUpdate (Viewport *vp)
| internal method for firing events
virtual void | fireViewportPostUpdate (Viewport *vp)
| internal method for firing events
virtual void | fireViewportAdded (Viewport *vp)
| internal method for firing events
virtual void | fireViewportRemoved (Viewport *vp)
| internal method for firing events
virtual void | updateImpl ()
| Internal implementation of update().
## Protected Attributes
bool | mIsFullScreen
bool | mIsPrimary
bool | mAutoDeactivatedOnFocusChange
int | mLeft
int | mTop
String | mName
| The name of this target.
uchar | mPriority
| The priority of the render target.
unsigned int | mWidth
unsigned int | mHeight
unsigned int | mColourDepth
bool | mIsDepthBuffered
FrameStats | mStats
Timer * | mTimer
unsigned long | mLastSecond
unsigned long | mLastTime
size_t | mFrameCount
bool | mActive
bool | mAutoUpdate
bool | mHwGamma
uint | mFSAA
String | mFSAAHint
ViewportList | mViewportList
| List of viewports, map on Z-order.
RenderTargetListenerList | mListeners
## Friends
class | Root

## Detailed Description

Manages the target rendering window.

Remarks:
  This class handles a window into which the contents of a scene are rendered. There is a many-to-1 relationship between instances of this class an instance of RenderSystem which controls the rendering of the scene. There may be more than one window in the case of level editor tools etc. This class is abstract since there may be different implementations for different windowing systems.
  Instances are created and communicated with by the render system although client programs can get a reference to it from the render system if required for resizing or moving. Note that you can have multiple viewpoints in the window for effects like rear-view mirrors and picture-in-picture views (see Viewport and Camera).

Author:
  Steven Streeting

Version:
  1.0

Definition at line 62 of file OgreRenderWindow.h.

## Member Typedef Documentation

typedef vector<RenderTargetListener*>::type Ogre::RenderTarget::RenderTargetListenerList`[protected, inherited]`

Definition at line 475 of file OgreRenderTarget.h.

typedef map<int, Viewport*>::type Ogre::RenderTarget::ViewportList`[protected, inherited]`

Definition at line 471 of file OgreRenderTarget.h.

## Member Enumeration Documentation

enum Ogre::RenderTarget::FrameBuffer`[inherited]`

Enumerator:

  FB_FRONT |
  FB_BACK |
  FB_AUTO |

Definition at line 90 of file OgreRenderTarget.h.

enum Ogre::RenderTarget::StatFlags`[inherited]`

Enumerator:

  SF_NONE |
  SF_FPS |
  SF_AVG_FPS |
  SF_BEST_FPS |
  SF_WORST_FPS |
  SF_TRIANGLE_COUNT |
  SF_ALL |

Definition at line 67 of file OgreRenderTarget.h.

## Constructor & Destructor Documentation

Ogre::RenderWindow::RenderWindow | ( |  | ) |

Default constructor.

## Member Function Documentation

virtual void Ogre::RenderTarget::_beginUpdate | ( |  | ) | `[virtual, inherited]`

Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.

Remarks:
  - _beginUpdate resets statistics and fires 'preRenderTargetUpdate'.
  - _updateViewport renders the given viewport (even if it is not autoupdated), fires preViewportUpdate and postViewportUpdate and manages statistics.
  - _updateAutoUpdatedViewports renders only viewports that are auto updated, fires preViewportUpdate and postViewportUpdate and manages statistics.
  - _endUpdate() ends statistics calculation and fires postRenderTargetUpdate.
  you can use it like this for example :

      			renderTarget->_beginUpdate();
      			renderTarget->_updateViewport(1); // which is not auto updated
      			renderTarget->_updateViewport(2); // which is not auto updated
      			renderTarget->_updateAutoUpdatedViewports();
      			renderTarget->_endUpdate();
      			renderTarget->swapBuffers(true);

  Please note that in that case, the zorder may not work as you expect, since you are responsible for calling _updateViewport in the correct order.

virtual void Ogre::RenderTarget::_endUpdate | ( |  | ) | `[virtual, inherited]`

Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.

Remarks:
  You should call it after a _beginUpdate

See also:
  _beginUpdate for more details.

virtual Impl* Ogre::RenderTarget::_getImpl | ( |  | ) | `[virtual, inherited]`

Get rendersystem specific interface for this RenderTarget.

This is used by the RenderSystem to (un)bind this target, and to get specific information like surfaces and framebuffer objects.

virtual void Ogre::RenderTarget::_notifyCameraRemoved | ( | const Camera * | cam | ) | `[virtual, inherited]`

Utility method to notify a render target that a camera has been removed, incase it was referring to it as a viewer.

void Ogre::RenderWindow::_setPrimary | ( |  | ) | `[protected]`

Indicates that this is the primary window.

Only to be called by Ogre::Root

Definition at line 182 of file OgreRenderWindow.h.

virtual void Ogre::RenderTarget::_updateAutoUpdatedViewports | ( | bool | updateStatistics = `true` | ) | `[virtual, inherited]`

Method for manual management of rendering - renders only viewports that are auto updated.

Remarks:
  This also fires preViewportUpdate and postViewportUpdate, and manages statistics. You should call it between _beginUpdate() and _endUpdate(). See _beginUpdate for more details.

Parameters:

  | updateStatistics | Whether you want to update statistics or not.

See also:
  _beginUpdate()

virtual void Ogre::RenderTarget::_updateViewport | ( | Viewport * | viewport,
|  | bool | updateStatistics = `true` |
| ) |  |  | `[virtual, inherited]`

Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).

Remarks:
  This also fires preViewportUpdate and postViewportUpdate, and manages statistics if needed. You should call it between _beginUpdate() and _endUpdate().

See also:
  _beginUpdate for more details.

Parameters:

  | viewport | The viewport you want to update, it must be bound to the rendertarget.
  | updateStatistics | Whether you want to update statistics or not.

virtual void Ogre::RenderTarget::_updateViewport | ( | int | zorder,
|  | bool | updateStatistics = `true` |
| ) |  |  | `[virtual, inherited]`

Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).

Remarks:
  This also fires preViewportUpdate and postViewportUpdate, and manages statistics. You should call it between _beginUpdate() and _endUpdate().

See also:
  _beginUpdate for more details.

Parameters:

  | zorder | The zorder of the viewport to update.
  | updateStatistics | Whether you want to update statistics or not.

virtual void Ogre::RenderTarget::addListener | ( | RenderTargetListener * | listener | ) | `[virtual, inherited]`

Add a listener to this RenderTarget which will be called back before & after rendering.

Remarks:
  If you want notifications before and after a target is updated by the system, use this method to register your own custom RenderTargetListener class. This is useful for potentially adding your own manual rendering commands before and after the 'normal' system rendering.

NB this should not be used for frame-based scene updates, use Root::addFrameListener for that.

virtual Viewport* Ogre::RenderTarget::addViewport | ( | Camera * | cam,
|  | int | ZOrder = `0`,
|  | float | left = `0.0f`,
|  | float | top = `0.0f`,
|  | float | width = `1.0f`,
|  | float | height = `1.0f` |
| ) |  |  | `[virtual, inherited]`

Adds a viewport to the rendering target.

Remarks:
  A viewport is the rectangle into which rendering output is sent. This method adds a viewport to the render target, rendering from the supplied camera. The rest of the parameters are only required if you wish to add more than one viewport to a single rendering target. Note that size information passed to this method is passed as a parametric, i.e. it is relative rather than absolute. This is to allow viewports to automatically resize along with the target.

Parameters:

  | cam | The camera from which the viewport contents will be rendered (mandatory)
  | ZOrder | The relative order of the viewport with others on the target (allows overlapping viewports i.e. picture-in-picture). Higher ZOrders are on top of lower ones. The actual number is irrelevant, only the relative ZOrder matters (you can leave gaps in the numbering)
  | left | The relative position of the left of the viewport on the target, as a value between 0 and 1.
  | top | The relative position of the top of the viewport on the target, as a value between 0 and 1.
  | width | The relative width of the viewport on the target, as a value between 0 and 1.
  | height | The relative height of the viewport on the target, as a value between 0 and 1.

virtual void Ogre::RenderTarget::copyContentsToMemory | ( | const PixelBox & | dst,
|  | FrameBuffer | buffer = `FB_AUTO` |
| ) |  |  | `[pure virtual, inherited]`

Copies the current contents of the render target to a pixelbox.

Remarks:
  See suggestPixelFormat for a tip as to the best pixel format to extract into, although you can use whatever format you like and the results will be converted.

Implemented in Ogre::RenderTexture, and Ogre::MultiRenderTarget.

virtual void Ogre::RenderWindow::create | ( | const String & | name,
|  | unsigned int | width,
|  | unsigned int | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams |
| ) |  |  | `[pure virtual]`

Creates & displays the new window.

Parameters:

  | width | The width of the window in pixels.
  | height | The height of the window in pixels.
  | colourDepth | The colour depth in bits. Ignored if fullScreen is false since the desktop depth is used.
  | fullScreen | If true, the window fills the screen, with no title bar or border.
  | left | The x-position of the window. Ignored if fullScreen = true.
  | top | The y-position of the window. Ignored if fullScreen = true.
  | depthBuffer | Specify true to include a depth-buffer.
  | miscParam | A variable number of pointers to platform-specific arguments. The actual requirements must be defined by the implementing subclasses.

virtual void Ogre::RenderWindow::destroy | ( | void |  | ) | `[pure virtual]`

Destroys the window.

virtual void Ogre::RenderTarget::firePostUpdate | ( | void |  | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual void Ogre::RenderTarget::firePreUpdate | ( | void |  | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual void Ogre::RenderTarget::fireViewportAdded | ( | Viewport * | vp | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual void Ogre::RenderTarget::fireViewportPostUpdate | ( | Viewport * | vp | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual void Ogre::RenderTarget::fireViewportPreUpdate | ( | Viewport * | vp | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual void Ogre::RenderTarget::fireViewportRemoved | ( | Viewport * | vp | ) | `[protected, virtual, inherited]`

internal method for firing events

virtual float Ogre::RenderTarget::getAverageFPS | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the average frames per second (FPS) since call to Root::startRendering.

virtual size_t Ogre::RenderTarget::getBatchCount | ( | void |  | ) | const`[virtual, inherited]`

Gets the number of batches rendered in the last update() call.

virtual float Ogre::RenderTarget::getBestFPS | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the best frames per second (FPS) since call to Root::startRendering.

virtual float Ogre::RenderTarget::getBestFrameTime | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the best frame time.

virtual unsigned int Ogre::RenderTarget::getColourDepth | ( | void |  | ) | const`[virtual, inherited]`

virtual void Ogre::RenderTarget::getCustomAttribute | ( | const String & | name,
|  | void * | pData |
| ) |  |  | `[virtual, inherited]`

Gets a custom (maybe platform-specific) attribute.

Remarks:
  This is a nasty way of satisfying any API's need to see platform-specific details. It horrid, but D3D needs this kind of info. At least it's abstracted.

Parameters:

  | name | The name of the attribute.
  | pData | Pointer to memory of the right kind of structure to receive the info.

virtual uint Ogre::RenderTarget::getFSAA | ( |  | ) | const`[virtual, inherited]`

Indicates whether multisampling is performed on rendering and at what level.

Definition at line 357 of file OgreRenderTarget.h.

virtual const String& Ogre::RenderTarget::getFSAAHint | ( |  | ) | const`[virtual, inherited]`

Gets the FSAA hint (.

See also:
  Root::createRenderWindow)

Definition at line 361 of file OgreRenderTarget.h.

virtual unsigned int Ogre::RenderTarget::getHeight | ( | void |  | ) | const`[virtual, inherited]`

virtual float Ogre::RenderTarget::getLastFPS | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the number of frames per second (FPS) based on the last frame rendered.

virtual void Ogre::RenderTarget::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height,
|  | unsigned int & | colourDepth |
| ) |  |  | `[virtual, inherited]`

Retrieve information about the render target.

virtual void Ogre::RenderWindow::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height,
|  | unsigned int & | colourDepth,
|  | int & | left,
|  | int & | top |
| ) |  |  | `[virtual]`

Overloaded version of getMetrics from RenderTarget, including extra details specific to windowing systems.

virtual const String& Ogre::RenderTarget::getName | ( | void |  | ) | const`[virtual, inherited]`

Retrieve target's name.

virtual unsigned short Ogre::RenderTarget::getNumViewports | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of viewports attached to this target.

virtual uchar Ogre::RenderTarget::getPriority | ( |  | ) | const`[virtual, inherited]`

Gets the priority of a render target.

Definition at line 281 of file OgreRenderTarget.h.

virtual void Ogre::RenderTarget::getStatistics | ( | float & | lastFPS,
|  | float & | avgFPS,
|  | float & | bestFPS,
|  | float & | worstFPS |
| ) |  |  | const`[virtual, inherited]`

Retieves details of current rendering performance.

Remarks:
  If the user application wishes to do it's own performance display, or use performance for some other means, this method allows it to retrieve the statistics.

Parameters:

  | lastFPS | Pointer to a float to receive the number of frames per second (FPS) based on the last frame rendered.
  | avgFPS | Pointer to a float to receive the FPS rating based on an average of all the frames rendered since rendering began (the call to Root::startRendering).
  | bestFPS | Pointer to a float to receive the best FPS rating that has been achieved since rendering began.
  | worstFPS | Pointer to a float to receive the worst FPS rating seen so far.

virtual const FrameStats& Ogre::RenderTarget::getStatistics | ( | void |  | ) | const`[virtual, inherited]`

virtual size_t Ogre::RenderTarget::getTriangleCount | ( | void |  | ) | const`[virtual, inherited]`

Gets the number of triangles rendered in the last update() call.

virtual Viewport* Ogre::RenderTarget::getViewport | ( | unsigned short | index | ) | `[virtual, inherited]`

Retrieves a pointer to the viewport with the given index.

virtual unsigned int Ogre::RenderTarget::getWidth | ( | void |  | ) | const`[virtual, inherited]`

virtual float Ogre::RenderTarget::getWorstFPS | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the worst frames per second (FPS) since call to Root::startRendering.

virtual float Ogre::RenderTarget::getWorstFrameTime | ( |  | ) | const`[virtual, inherited]`

Individual stats access - gets the worst frame time.

virtual bool Ogre::RenderWindow::isActive | ( | void |  | ) | const`[virtual]`

Overridden from RenderTarget, flags invisible windows as inactive.

Reimplemented from Ogre::RenderTarget.

Definition at line 135 of file OgreRenderWindow.h.

virtual bool Ogre::RenderTarget::isAutoUpdated | ( | void |  | ) | const`[virtual, inherited]`

Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

virtual bool Ogre::RenderWindow::isClosed | ( | void |  | ) | const`[pure virtual]`

Indicates whether the window has been closed by the user.

bool Ogre::RenderWindow::isDeactivatedOnFocusChange | ( |  | ) | const

Returns true if the window will automatically de-activate itself when it loses focus.

virtual bool Ogre::RenderWindow::isFullScreen | ( | void |  | ) | const`[virtual]`

Returns true if window is running in fullscreen mode.

virtual bool Ogre::RenderTarget::isHardwareGammaEnabled | ( |  | ) | const`[virtual, inherited]`

Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.

This is the exact opposite conversion of what is indicated by Texture::isHardwareGammaEnabled, and can only be enabled on creation of the render target. For render windows, it's enabled through the 'gamma' creation misc parameter. For textures, it is enabled through the hwGamma parameter to the create call.

Definition at line 353 of file OgreRenderTarget.h.

virtual bool Ogre::RenderWindow::isPrimary | ( | void |  | ) | const`[virtual]`

Indicates whether the window is the primary window.

The primary window is special in that it is destroyed when ogre is shut down, and cannot be destroyed directly. This is the case because it holds the context for vertex, index buffers and textures.

Reimplemented from Ogre::RenderTarget.

virtual bool Ogre::RenderWindow::isVisible | ( | void |  | ) | const`[virtual]`

Indicates whether the window is visible (not minimized or obscured).

Definition at line 126 of file OgreRenderWindow.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::RenderTarget::removeAllListeners | ( | void |  | ) | `[virtual, inherited]`

Removes all listeners from this instance.

virtual void Ogre::RenderTarget::removeAllViewports | ( | void |  | ) | `[virtual, inherited]`

Removes all viewports on this target.

virtual void Ogre::RenderTarget::removeListener | ( | RenderTargetListener * | listener | ) | `[virtual, inherited]`

Removes a RenderTargetListener previously registered using addListener.

virtual void Ogre::RenderTarget::removeViewport | ( | int | ZOrder | ) | `[virtual, inherited]`

Removes a viewport at a given ZOrder.

virtual void Ogre::RenderWindow::reposition | ( | int | left,
|  | int | top |
| ) |  |  | `[pure virtual]`

Reposition the window.

virtual bool Ogre::RenderTarget::requiresTextureFlipping | ( |  | ) | const`[pure virtual, inherited]`

virtual void Ogre::RenderTarget::resetStatistics | ( | void |  | ) | `[virtual, inherited]`

Resets saved frame-rate statistices.

virtual void Ogre::RenderWindow::resize | ( | unsigned int | width,
|  | unsigned int | height |
| ) |  |  | `[pure virtual]`

Alter the size of the window.

virtual void Ogre::RenderTarget::setActive | ( | bool | state | ) | `[virtual, inherited]`

Used to set the active state of the render target.

virtual void Ogre::RenderTarget::setAutoUpdated | ( | bool | autoupdate | ) | `[virtual, inherited]`

Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.

Remarks:
  By default, if you use Ogre's own rendering loop (Root::startRendering) or call Root::_updateAllRenderTargets, all render targets are updated automatically. This method allows you to control that behaviour, if for example you have a render target which you only want to update periodically.

Parameters:

  | autoupdate | If true, the render target is updated during the automatic render loop or when Root::_updateAllRenderTargets is called. If false, the target is only updated when its update() method is called explicitly.

void Ogre::RenderWindow::setDeactivateOnFocusChange | ( | bool | deactivate | ) |

Indicates whether the window will automatically deactivate itself when it loses focus.

Parameters:

  | deactivate | a value of 'true' will cause the window to deactivate itself when it loses focus. 'false' will allow it to continue to render even when window focus is lost.

Note:
  'true' is the default behavior.

virtual void Ogre::RenderWindow::setFullscreen | ( | bool | fullScreen,
|  | unsigned int | width,
|  | unsigned int | height |
| ) |  |  | `[virtual]`

Alter fullscreen mode options.

Note:
  Nothing will happen unless the settings here are different from the current settings.

Parameters:

  | fullScreen | Whether to use fullscreen mode or not.
  | width | The new width to use
  | height | The new height to use

Definition at line 103 of file OgreRenderWindow.h.

virtual void Ogre::RenderTarget::setPriority | ( | uchar | priority | ) | `[virtual, inherited]`

Sets the priority of this render target in relation to the others.

Remarks:
  This can be used in order to schedule render target updates. Lower priorities will be rendered first. Note that the priority must be set at the time the render target is attached to the render system, changes afterwards will not affect the ordering.

Definition at line 279 of file OgreRenderTarget.h.

virtual void Ogre::RenderWindow::setVisible | ( | bool | visible | ) | `[virtual]`

Set the visibility state.

Definition at line 130 of file OgreRenderWindow.h.

PixelFormat Ogre::RenderWindow::suggestPixelFormat | ( |  | ) | const`[virtual]`

Override since windows don't usually have alpha.

Reimplemented from Ogre::RenderTarget.

Definition at line 160 of file OgreRenderWindow.h.

virtual void Ogre::RenderTarget::swapBuffers | ( | bool | waitForVSync = `true` | ) | `[virtual, inherited]`

Swaps the frame buffers to display the next frame.

Remarks:
  For targets that are double-buffered so that no 'in-progress' versions of the scene are displayed during rendering. Once rendering has completed (to an off-screen version of the window) the buffers are swapped to display the new frame.

Parameters:

  | waitForVSync | If true, the system waits for the next vertical blank period (when the CRT beam turns off as it travels from bottom-right to top-left at the end of the pass) before flipping. If false, flipping occurs no matter what the beam position. Waiting for a vertical blank can be slower (and limits the framerate to the monitor refresh rate) but results in a steadier image with no 'tearing' (a flicker resulting from flipping buffers when the beam is in the progress of drawing the last frame).

Definition at line 153 of file OgreRenderTarget.h.

virtual void Ogre::RenderTarget::update | ( | bool | swapBuffers = `true` | ) | `[virtual, inherited]`

Tells the target to update it's contents.

Remarks:
  If OGRE is not running in an automatic rendering loop (started using Root::startRendering), the user of the library is responsible for asking each render target to refresh. This is the method used to do this. It automatically re-renders the contents of the target using whatever cameras have been pointed at it (using Camera::setRenderTarget).

  This allows OGRE to be used in multi-windowed utilities and for contents to be refreshed only when required, rather than constantly as with the automatic rendering loop.

Parameters:

  | swapBuffers | For targets that support double-buffering, if set to true, the target will immediately swap it's buffers after update. Otherwise, the buffers are not swapped, and you have to call swapBuffers yourself sometime later. You might want to do this on some rendersystems which pause for queued rendering commands to complete before accepting swap buffers calls - so you could do other CPU tasks whilst the queued commands complete. Or, you might do this if you want custom control over your windows, such as for externally created windows.

virtual void Ogre::RenderTarget::updateImpl | ( |  | ) | `[protected, virtual, inherited]`

Internal implementation of update().

void Ogre::RenderTarget::updateStats | ( | void |  | ) | `[protected, inherited]`

virtual void Ogre::RenderWindow::windowMovedOrResized | ( |  | ) | `[virtual]`

Notify that the window has been resized.

Remarks:
  You don't need to call this unless you created the window externally.

Definition at line 118 of file OgreRenderWindow.h.

void Ogre::RenderTarget::writeContentsToFile | ( | const String & | filename | ) | `[inherited]`

Writes the current contents of the render target to the named file.

virtual String Ogre::RenderTarget::writeContentsToTimestampedFile | ( | const String & | filenamePrefix,
|  | const String & | filenameSuffix |
| ) |  |  | `[virtual, inherited]`

Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

Returns:
  the name of the file used.

## Friends And Related Function Documentation

friend class Root`[friend]`

Definition at line 184 of file OgreRenderWindow.h.

## Member Data Documentation

bool Ogre::RenderTarget::mActive`[protected, inherited]`

Definition at line 461 of file OgreRenderTarget.h.

bool Ogre::RenderWindow::mAutoDeactivatedOnFocusChange`[protected]`

Definition at line 175 of file OgreRenderWindow.h.

bool Ogre::RenderTarget::mAutoUpdate`[protected, inherited]`

Definition at line 462 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mColourDepth`[protected, inherited]`

Definition at line 450 of file OgreRenderTarget.h.

size_t Ogre::RenderTarget::mFrameCount`[protected, inherited]`

Definition at line 459 of file OgreRenderTarget.h.

uint Ogre::RenderTarget::mFSAA`[protected, inherited]`

Definition at line 466 of file OgreRenderTarget.h.

String Ogre::RenderTarget::mFSAAHint`[protected, inherited]`

Definition at line 467 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mHeight`[protected, inherited]`

Definition at line 449 of file OgreRenderTarget.h.

bool Ogre::RenderTarget::mHwGamma`[protected, inherited]`

Definition at line 464 of file OgreRenderTarget.h.

bool Ogre::RenderTarget::mIsDepthBuffered`[protected, inherited]`

Definition at line 451 of file OgreRenderTarget.h.

bool Ogre::RenderWindow::mIsFullScreen`[protected]`

Definition at line 173 of file OgreRenderWindow.h.

bool Ogre::RenderWindow::mIsPrimary`[protected]`

Definition at line 174 of file OgreRenderWindow.h.

unsigned long Ogre::RenderTarget::mLastSecond`[protected, inherited]`

Definition at line 457 of file OgreRenderTarget.h.

unsigned long Ogre::RenderTarget::mLastTime`[protected, inherited]`

Definition at line 458 of file OgreRenderTarget.h.

int Ogre::RenderWindow::mLeft`[protected]`

Definition at line 176 of file OgreRenderWindow.h.

RenderTargetListenerList Ogre::RenderTarget::mListeners`[protected, inherited]`

Definition at line 476 of file OgreRenderTarget.h.

String Ogre::RenderTarget::mName`[protected, inherited]`

The name of this target.

Definition at line 444 of file OgreRenderTarget.h.

uchar Ogre::RenderTarget::mPriority`[protected, inherited]`

The priority of the render target.

Definition at line 446 of file OgreRenderTarget.h.

FrameStats Ogre::RenderTarget::mStats`[protected, inherited]`

Definition at line 454 of file OgreRenderTarget.h.

Timer* Ogre::RenderTarget::mTimer`[protected, inherited]`

Definition at line 456 of file OgreRenderTarget.h.

int Ogre::RenderWindow::mTop`[protected]`

Definition at line 177 of file OgreRenderWindow.h.

ViewportList Ogre::RenderTarget::mViewportList`[protected, inherited]`

List of viewports, map on Z-order.

Definition at line 473 of file OgreRenderTarget.h.

unsigned int Ogre::RenderTarget::mWidth`[protected, inherited]`

Definition at line 448 of file OgreRenderTarget.h.

The documentation for this class was generated from the following file:

- OgreRenderWindow.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:59